﻿var dataCollection = [];

function initSaveData(id, coll) {//initial data save
    var temp = dataConversion(coll);
    temp.unshift(id); //add ID in front of array
    dataCollection.push(temp);// [id,timearr, piearr]
    console.log("#CREATION: " + id);
}
function saveData(id, coll) {
    var temp = dataConversion(coll);
    for (var i = 0; i < dataCollection.length; i++) {
        if (dataCollection[i][0] == id) {
            dataCollection[i][1] = temp[0];
            dataCollection[i][2] = temp[1];
        }
    }
    console.log("#SAVEDATA: " + id);
    redrawGraph(id);
}
function getData(id) {
    for (var i = 0; i < dataCollection.length; i++) {
        if (dataCollection[i][0] == id) {
            return dataCollection[i][1];
        }
    }
}
function getDataPie(id) {
    for (var i = 0; i < dataCollection.length; i++) {
        if (dataCollection[i][0] == id) {
            return dataCollection[i][2];
        }
    }

}
function dataConversion(coll) {
    var xarr = [];
    var yarr = [];
    var waiting = 0;
    var transfer = 0;
    var calc = 0;
    for (var v = 0; v < coll.length; v++) {
        xarr.push(coll[v].DateTime.substr(11, 8));
        if (coll[v].State == 1) {
            yarr.push("Waiting");
            if (v < (coll.length - 1))
                waiting += Date.parse(coll[v + 1].DateTime) - Date.parse(coll[v].DateTime);
        }
        else if (coll[v].State == 2) {
            yarr.push("Transferring");
            if (v < (coll.length - 1))
                transfer += Date.parse(coll[v + 1].DateTime) - Date.parse(coll[v].DateTime);
        }
        else if (coll[v].State == 3) {
            yarr.push("Calculating");
            if (v < (coll.length - 1))
                calc += Date.parse(coll[v + 1].DateTime) - Date.parse(coll[v].DateTime);
        }
        else if (coll[v].State == 5)
            yarr.push("Finished");
        else if (coll[v].State == 7)
            yarr.push("Failed");
    }
    var data = [{//Time graph
        x: xarr,
        y: yarr,
        type: 'scatter'
    }];
    var datap = [{//Pie graph
        values: [
            Math.round(waiting / 1000 / 60),
            Math.round(transfer / 1000 / 60),
            Math.round(calc / 1000 / 60)],
        labels: [
            'Minutes waiting',
            'Minutes transferring',
            'Minutes calculating'],
        type: 'pie'
    }];
    return [data, datap];
}

function redrawGraph(val) {
    if (document.getElementById("graphtoggle" + val).checked) {
        setTimeout(function () {
            Plotly.newPlot('graph' + val, getData(val));
        }, 100);
        console.log("#REDRAWN LINE: " + val);
    } else {
        setTimeout(function () {
            Plotly.newPlot('graph' + val, getDataPie(val));
        }, 100);
        console.log("#REDRAWN PIE: " + val);
    }

}